local player_texture = Resources.load_texture("battle.png")

function player_init(player)
    player:set_name("Kirby")
    -- player:set_health(1000)
    player:set_element(Element.None)
    player:set_height(20.0)
    player:set_charge_position(1, -8)
    player:load_animation("battle.animation")
    player:set_texture(player_texture)

    player.on_spawn_func = function(self)
        -- Install Kirby's theme song on spawning
        self:boost_augment("KirbyMusic.GourmetRace", 1)
    end

    player.on_update_func = function(self)
        -- nothing in particular
    end

    -- Pea Shot is regular damage
    player.normal_attack_func = function(self)
        return Buster.new(self, false, player:attack_level() * 1)
    end

    -- Charge Shot is damage * 10
    player.charged_attack_func = function(self)
        return Buster.new(self, true, player:attack_level() * 10)
    end

    -- Kirby can copy the action of any Card that he can hold which does not stop time and is compatible with Charging.
    player.can_charge_card_func = function(card_properties)
        return card_properties.can_charge ~= false and card_properties.time_freeze ~= true
    end

    player.charged_card_func = function(self, card_properties)
        -- Redefine Charge Shot to use the charged card
        player.charged_attack_func = function(actor)
            return Action.from_card(actor, card_properties);
        end
        return Action.new(self, "CHARACTER_SHOOT")
    end
end
